﻿using System.Data.Common;
using System.Data.SqlServerCe;
using System.Windows;
using System.Windows.Data;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;
using System.ComponentModel;
using System;
using System.Data;
using System.Data.Objects;
using System.Xml.Linq;
using System.Configuration;
using Microsoft.Win32;

namespace AppTrans
{
    public partial class MainWindow : Window
    {
        db_trans4Entities database;

        public MainWindow()
        {
            InitializeComponent();
            InitializeData();
        }
        private void InitializeData()
        {
            database = new db_trans4Entities();
            MainPanel.DataContext = database;

            CheckVersionBD();

            //Запись в реестр Windows даты и времени входа в систему.
            RegistryKeyValues.SetValue("LastStartProgram", DateTime.Now.ToString());
            
            WorksDataGrid.ItemsSource = from w in database.Works
                                        orderby w.Date
                                        select w;

            TransactionsDataGrid.ItemsSource = from t in database.Transactions
                                               orderby t.Date
                                               select t;

            //Справочники для полей типа ComboBox таблицы Works
            WorksLoadingPlaceList.ItemsSource = from DictionaryPlaces in database.DictionaryPlaces
                                                where DictionaryPlaces.View == 1
                                                orderby DictionaryPlaces.Name
                                                select new
                                                {
                                                    Id = DictionaryPlaces.Id,
                                                    Name = DictionaryPlaces.Name
                                                };
            WorksUnloadingPlaceList.ItemsSource = from DictionaryPlaces in database.DictionaryPlaces
                                                  where DictionaryPlaces.View == 1
                                                  orderby DictionaryPlaces.Name
                                                  select new
                                                  { Id = DictionaryPlaces.Id,
                                                  Name = DictionaryPlaces.Name };
            WorksMachineList.ItemsSource = from DictionaryMachines in database.DictionaryMachines
                                           orderby DictionaryMachines.Name
                                           where DictionaryMachines.View == 1
                                           select new
                                           { Id = DictionaryMachines.Id,
                                           Name = DictionaryMachines.Name };
            WorksDriverList.ItemsSource = from DictionaryDrivers in database.DictionaryDrivers
                                          orderby DictionaryDrivers.Name
                                          where DictionaryDrivers.View == 1
                                          select new
                                          { Id = DictionaryDrivers.Id,
                                          Name = DictionaryDrivers.Name };
            WorksGoodsList.ItemsSource = from DictionaryGoods in database.DictionaryGoods
                                         orderby DictionaryGoods.Name
                                         where DictionaryGoods.View == 1
                                         select new
                                         { Id = DictionaryGoods.Id,
                                         Name = DictionaryGoods.Name };
            WorksSupplierList.ItemsSource = from DictionaryPartners in database.DictionaryPartners
                                            orderby DictionaryPartners.Name
                                            where DictionaryPartners.View == 1 || DictionaryPartners.Supplier == 1
                                            select new
                                            { Id = DictionaryPartners.Id,
                                            Name = DictionaryPartners.Name };
            WorksCurrencyPurchasingList.ItemsSource = from DictionaryCurrencies in database.DictionaryCurrencies
                                                      orderby DictionaryCurrencies.Name
                                                      where DictionaryCurrencies.View == 1
                                                      select new
                                                      { Id = DictionaryCurrencies.Id,
                                                      ShortName = DictionaryCurrencies.ShortName };
            WorksSupplierCommissionList.ItemsSource = from DictionaryPartners in database.DictionaryPartners
                                            orderby DictionaryPartners.Name
                                            where DictionaryPartners.View == 1 || DictionaryPartners.SupplierCommission == 1

                                            select new
                                            {
                                                Id = DictionaryPartners.Id,
                                                Name = DictionaryPartners.Name
                                            };
            WorksCustomerList.ItemsSource = from DictionaryPartners in database.DictionaryPartners
                                            orderby DictionaryPartners.Name
                                            where DictionaryPartners.View == 1 || DictionaryPartners.Customer == 1
                                            select new
                                            { Id = DictionaryPartners.Id,
                                            Name = DictionaryPartners.Name };         
            WorksCurrencySalesList.ItemsSource = from DictionaryCurrencies in database.DictionaryCurrencies
                                                 orderby DictionaryCurrencies.Name
                                                 where DictionaryCurrencies.View == 1
                                                 select new
                                                 { Id = DictionaryCurrencies.Id,
                                                 ShortName = DictionaryCurrencies.ShortName };
            WorksCustomerCommissionList.ItemsSource = from DictionaryPartners in database.DictionaryPartners
                                            orderby DictionaryPartners.Name
                                                      where DictionaryPartners.View == 1 || DictionaryPartners.CustomerCommission == 1
                                            select new
                                            {
                                                Id = DictionaryPartners.Id,
                                                Name = DictionaryPartners.Name
                                            };
            WorksProjectList.ItemsSource = from DictionaryProjects in database.DictionaryProjects
                                           orderby DictionaryProjects.Name
                                           where DictionaryProjects.View == 1
                                           select new
                                           { Id = DictionaryProjects.Id,
                                           Name = DictionaryProjects.Name };

            //Справочники для полей типа ComboBox таблицы Transactions
            TransactionsTypeList.ItemsSource = database.DictionaryTransactionTypes;
            TransactionsCurrencyList.ItemsSource = from DictionaryCurrencies in database.DictionaryCurrencies
                                                   orderby DictionaryCurrencies.Name
                                                   where DictionaryCurrencies.View == 1
                                                   select new
                                                   { Id = DictionaryCurrencies.Id,
                                                   ShortName = DictionaryCurrencies.ShortName };
            TransactionsCategoryList.ItemsSource = from DictionaryCategories in database.DictionaryCategories
                                                   orderby DictionaryCategories.DictionaryTransactionType.Id
                                                   where DictionaryCategories.View == 1
                                                   select new
                                                   { Id = DictionaryCategories.Id,
                                                   Name = DictionaryCategories.Name + " (" + DictionaryCategories.DictionaryTransactionType.Name + ")" };
            TransactionsPartnerList.ItemsSource = from DictionaryPartners in database.DictionaryPartners
                                                  orderby DictionaryPartners.Name
                                                  where DictionaryPartners.View == 1 || DictionaryPartners.FinPartner == 1
                                                  select new
                                                  { Id = DictionaryPartners.Id,
                                                  Name = DictionaryPartners.Name };
            TransactionsDriverList.ItemsSource = from DictionaryDrivers in database.DictionaryDrivers
                                                 orderby DictionaryDrivers.Name
                                                 where DictionaryDrivers.View == 1
                                                 select new
                                                 { Id = DictionaryDrivers.Id,
                                                 Name = DictionaryDrivers.Name };
            TransactionsProjectList.ItemsSource = from DictionaryProjects in database.DictionaryProjects
                                                  orderby DictionaryProjects.Name
                                                  where DictionaryProjects.View == 1
                                                  select new
                                                  { Id = DictionaryProjects.Id,
                                                  Name = DictionaryProjects.Name };

            DictionaryCategoriesTypeList.ItemsSource = database.DictionaryTransactionTypes;

            DateTime varFinFromDate;
            DateTime varFinToDate;
            DateTime varWorkFromDate;
            DateTime varWorkToDate;
            GetSetDataRepConstructor(out varFinFromDate, out varFinToDate, out varWorkFromDate, out varWorkToDate);

            //CheckDateParam(varFinFromDate, varFinToDate, varWorkFromDate, varWorkToDate);

            WorkReportConstructor(varWorkFromDate, varWorkToDate);
            FinanceReportConstructor(varFinFromDate, varFinToDate);
            
            //Reports Kassa
            Kassa.ItemsSource = database.ExecuteStoreQuery<KassaObject>(KassaObject.sql);
            //Reports Receivables
            Receivables.ItemsSource = database.ExecuteStoreQuery<ReceivablesObject>(ReceivablesObject.sql);
            //Reports Payables
            Payables.ItemsSource = database.ExecuteStoreQuery<PayablesObject>(PayablesObject.sql);
            //Reports Categories
            ReportCategories.ItemsSource = database.ExecuteStoreQuery<ReportCategoriesObject>(ReportCategoriesObject.sql);
            //Reports Procent
            ReportProcent.ItemsSource = database.ExecuteStoreQuery<ProcentObject>(ProcentObject.sql);
            //Reports Nalog
            ReportNalog.ItemsSource = database.ExecuteStoreQuery<ReportNalogObject>(ReportNalogObject.sql);
            //Reports Dolg
            ReportDolg.ItemsSource = database.ExecuteStoreQuery<ReportDolgObject>(ReportDolgObject.sql);
            //Report Error
            ReportError.ItemsSource = database.ExecuteStoreQuery<ReportErrorObject>(ReportErrorObject.sql);
            //Reports Receivables NEW
            ReceivablesNew.ItemsSource = database.ExecuteStoreQuery<ReceivablesObjectNew>(ReceivablesObjectNew.sql);
            //Reports Payables NEW
            PayablesNew.ItemsSource = database.ExecuteStoreQuery<PayablesObjectNew>(PayablesObjectNew.sql);
            //Reports Зарплата водителя
            ReportZPVoditel.ItemsSource = database.ExecuteStoreQuery<ReportZPVoditelObject>(ReportZPVoditelObject.sql);
            //Reports Комиссии
            ReportComission.ItemsSource = database.ExecuteStoreQuery<ReportComissionObject>(ReportComissionObject.sql);

            VersionDBDataGrid.ItemsSource = from t in database.VersionDBs
                                            orderby t.Id
                                            select new
                                            { Id = t.Id,
                                            Версия = t.Version,
                                            Дата_обновления = t.Data };
            ReportErrors();
        }

        public void GetSetDataRepConstructor(out DateTime varFinFromDate, out DateTime varFinToDate, out DateTime varWorkFromDate, out DateTime varWorkToDate)
        {
            varFinFromDate = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_FinFromDate).First().FinFromDate; ;
            varFinToDate = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_FinToDate).First().FinToDate;
            varWorkFromDate = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_WorkFromDate).First().WorkFromDate; ;
            varWorkToDate = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_WorkToDate).First().WorkToDate;
        }

        public void CheckVersionBD()
        {
            var resultCheckingTableVersionDB = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_CheckingTableVersionDB).First().CheckingTableVersionDB;
            if (resultCheckingTableVersionDB == 0)
            {
                //Вывод сообщения про отсутствие таблицы VersionDB
                resultCheckingTableVersionDB = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_CheckingTableVersionDB).First().CheckingTableVersionDB;
            }
            if (resultCheckingTableVersionDB == 1)
            {
                var versionDB = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_MaxVersionDB).First().MaxVersionDB;
                if (versionDB == 00)
                {
                    MessageBox.Show("Сейчас будет выполнено обновление БД.");
                    database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_insert_set1);
                    database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_insert_set2);
                    database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_insert_set3);
                    database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_insert_set4);
                    database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_InsertVersion10);
                    versionDB = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_MaxVersionDB).First().MaxVersionDB;
                    InitializeData();
                }
                if (versionDB == 10)
                {
                    //database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_InsertVersion20);
                    //versionDB = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_MaxVersionDB).First().MaxVersionDB;
                }
            }
        }

        /// <summary>
        /// Подготовка данных для конструктора "Работы"
        /// </summary>
        private void WorkReportConstructor(DateTime? fromDate = null, DateTime? toDate = null)
        {
            if (fromDate == null) fromDate = DateTime.MinValue;
            if (toDate == null) toDate = DateTime.MaxValue;
            WorksRep.ItemsSource = from work in database.Works
                                   where work.Date >= fromDate &&
                                         work.Date <= toDate
                                   orderby work.Date
                                   select new
                                   {
                                       Дата = work.Date,
                                       Месяц = work.Date.Month,
                                       Год = work.Date.Year,
                                       МестоЗагр = work.DictionaryPlace.Name,
                                       МестоРазгр = work.DictionaryPlace1.Name,
                                       Машина = work.DictionaryMachine.Name,
                                       Водитель = work.DictionaryDriver.Name,
                                       ЗарплВодит = work.SalaryDriver,
                                       Груз = work.DictionaryGood.Name,
                                       Вес = work.Weight,
                                       КолРаб = work.CountWork,
                                       Поставщик = work.DictionaryPartner.Name,
                                       СуммаЗакупки = work.PriceOfPurchasing,
                                       ВалютаЗакупки = work.DictionaryCurrency.ShortName,
                                       КомиссионерПоставщика = work.DictionaryPartner1.Name,
                                       СуммаКомисПоставщика = work.PriceCommissionPurchase,
                                       Заказчик = work.DictionaryPartner2.Name,
                                       СуммаПродажи = work.PriceOfSales,
                                       ВалютаПродажи = work.DictionaryCurrency1.ShortName,
                                       КомиссионерЗаказч = work.DictionaryPartner3,
                                       СуммаКомисЗаказч = work.PriceCommissionSales,
                                       Проект = work.DictionaryProject.Name,
                                       Описание = work.Discription
                                   };
        }
        
        /// <summary>
        /// Подготовка данных для конструктора "Финансы"
        /// </summary>
        private void FinanceReportConstructor(DateTime? fromDate = null, DateTime? toDate = null)
        {
            if (fromDate == null) fromDate = DateTime.MinValue;
            if (toDate == null) toDate = DateTime.MaxValue;
            FinRep.ItemsSource = from Transactions in database.Transactions
                                 where Transactions.Date >= fromDate &&
                                       Transactions.Date <= toDate
                                 orderby Transactions.Date
                                 select new
                                 {
                                     Дата = Transactions.Date,
                                     Месяц = Transactions.Date.Month,
                                     Год = Transactions.Date.Year,
                                     Тип = Transactions.DictionaryTransactionType.Name,
                                     Сумма = Transactions.Summa,
                                     Валюта = Transactions.DictionaryCurrency.ShortName,
                                     Категория = Transactions.DictionaryCategory.Name,
                                     Партнер = Transactions.DictionaryPartner.Name,
                                     Водитель = Transactions.DictionaryDriver.Name,
                                     Проект = Transactions.DictionaryProject.Name
                                 };
        }

        /// <summary>
        /// Уведомление про найденные ошибки
        /// </summary>
        private void ReportErrors()
        {
            var reportErrors = database.ExecuteStoreQuery<ReportErrorObject>(ReportErrorObject.sql);
            var i = 0;
            foreach (var reportError in reportErrors)
            {
                var errorsCountString = reportError.Кол_во_ошибок;
                var levelErrorsString = reportError.Уровень_ошибки;
                var errorsCount = 0;
                int.TryParse(errorsCountString, out errorsCount);

                if (errorsCount > 0 && levelErrorsString == "Критичный")
                {
                    i += errorsCount;
                }
            }
            if (i > 0)
            {
                MessageBox.Show("Найдены критические ошибки.\nПроверьте отчет Настройки --> Ошибки!\nКол-во критических ошибок = " + i, "Внимание, найдены ошибки!", MessageBoxButton.OK, MessageBoxImage.Warning);
            }
        }

        private void CheckErrors()
        {
            var reportErrors = database.ExecuteStoreQuery<ReportErrorObject>(ReportErrorObject.sql);
                int critical = 0;
                int warning = 0;
                int info = 0;
            foreach (var reportError in reportErrors)
            {
                var errorsCountString = reportError.Кол_во_ошибок;
                var levelErrorsString = reportError.Уровень_ошибки;
                var errorsCount = 0;

                int.TryParse(errorsCountString, out errorsCount);

                if (errorsCount > 0 && levelErrorsString == "Критичный")
                {
                    critical += errorsCount;
                }
                if (errorsCount > 0 && levelErrorsString == "Предупреждение")
                {
                    warning += errorsCount;
                }
                if (errorsCount > 0 && levelErrorsString == "Информационный")
                {
                    info += errorsCount;
                }
            }                
            MessageBox.Show("Кол-во критических ошибок = " + critical + "\nКол-во предупреждений = " + warning + "\nКол-во информационных сообщений = " + info, "Проверка на ошибки", MessageBoxButton.OK, MessageBoxImage.Warning);            
        }

        #region Events
        /// <summary>
        /// Были ли изменения в базе
        /// </summary>
        /// <returns>true, если база изменена</returns>
        private bool isDatabaseDirty()
        {
            return database.ObjectStateManager.GetObjectStateEntries(EntityState.Added | EntityState.Deleted | EntityState.Modified).Any();
        }

        private bool TryToSave()
        {
            try
            {
                database.SaveChanges();
            }
            catch (Exception exc)
            {
                StatusBarText.Text = "Ошибка при сохранении в " + DateTime.Now.TimeOfDay;
                MessageBox.Show(exc.InnerException.Message, "Ошибка при сохранении", MessageBoxButton.OK, MessageBoxImage.Error);
                return false;
            }

            return true;
        }

        private bool SaveDataConfirm()
        {
            /// Изменений в базе не было, значит не нужно запрашивать сохранение
            if (!isDatabaseDirty())
                return true;

            if (MessageBox.Show("Сохранить?", "Выход", MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.Yes)
                return TryToSave();

            return true;
        }

        void exitCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        void MainWindow_Closing(object sender, CancelEventArgs e)
        {
            var success = SaveDataConfirm();
            if (!success)
                e.Cancel = true;
        }

        void saveCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            if (TryToSave())
            {
                InitializeData();
                StatusBarText.Text = "Сохранено в " + DateTime.Now.TimeOfDay;
            }
        }

        void CheckErrors_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            CheckErrors();
        }

        void CheckDateParam_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            DateTime varFinFromDate;
            DateTime varFinToDate;
            DateTime varWorkFromDate;
            DateTime varWorkToDate;
            GetSetDataRepConstructor(out varFinFromDate, out varFinToDate, out varWorkFromDate, out varWorkToDate);
            MessageBox.Show("WorkDateFrom =" + varWorkFromDate + "\nWorkDateTo =" + varWorkToDate + "\nFinDateFrom =" + varFinFromDate + "\nFinDateTo =" + varFinToDate);
        }

        void RunSQL_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            byte EnableRunSQL = byte.MinValue;
            EnableRunSQL = byte.Parse(ConfigurationManager.AppSettings["EnableRunSQL"]);
            if (EnableRunSQL == 1)
            {
                ConfigurationManager.AppSettings["EnableRunSQL"] = "2";
                MessageBoxResult show = MessageBox.Show("Значение EnableRunSQL = " + EnableRunSQL);
            }
            if (EnableRunSQL == 2)
            {
                MessageBoxResult show = MessageBox.Show("Значение EnableRunSQL = " + EnableRunSQL);
            }
            else
            {
                MessageBoxResult show = MessageBox.Show("Некорректное значение параметра. \nEnableRunSQL = " + EnableRunSQL);
            }
        }

        void VerDB_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            var resultCheckingTableVersionDB2 = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_CheckingTableVersionDB).First().CheckingTableVersionDB;
            var versionDB2 = database.ExecuteStoreQuery<RunSQLObject>(RunSQLObject.sql_MaxVersionDB).First().MaxVersionDB;
            MessageBox.Show("Наличие таблицы VersionDB: " + resultCheckingTableVersionDB2 +
            "\nТекущая версия БД: " + versionDB2 +
            "\nВход в систему: " + RegistryKeyValues.GetValue("LastStartProgram"), "Версия БД");
        }

        void refreshCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            InitializeData();
            StatusBarText.Text = "Обновлено из базы в " + DateTime.Now.TimeOfDay;
        }

        #region Show windows

        void aboutCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            AboutWindow aboutWindow = new AboutWindow();
            aboutWindow.Show();
        }

        void HotkeysCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            HotkeysWindow HotkeysWindow = new HotkeysWindow();
            HotkeysWindow.Show();
        }

        void InstructionCommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            InstructionWindow InstructionWindow = new InstructionWindow();
            InstructionWindow.Show();
        }

        #endregion

        /// <summary>
        /// Клонирование строки. 
        /// Эту операцию можно выполнять только на сохраненной базе.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void WorksCloneButton_Click(object sender, RoutedEventArgs e)
        {
            if (isDatabaseDirty())
            {
                MessageBox.Show("Сохраните базу перед продолжением", "Clone", MessageBoxButton.OK, MessageBoxImage.Asterisk);
                return;
            }

            Work work = WorksDataGrid.SelectedItem as Work;
            if (work == null)
                return;

            database.Detach(work);
            database.Works.AddObject(work);

            work.Date = DateTime.Now;
            work.Weight = 0;
            work.PriceOfSales = 0;
            work.Discription = null;

            TryToSave();
            InitializeData();
        }
        #endregion
    }
}
