﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AppTrans
{
    class ReportErrorObject
    {
        public const string sql = @"
        select 'ОШИБКИ В ФИНАНСАХ:' as Тип_ошибки, '' as Кол_во_ошибок, '' as Уровень_ошибки
        union all
        select 'Не совпадает категория и тип транзакции' as TypeError, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Transactions t inner join DictionaryCategories dc on t.Category = dc.Id
        where t.Type != dc.Type
        union all
        select 'Для категории ""Зарплата водителя"" не заполнено поле ""Водитель""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Transactions t 
        where t.Category in (select convert(int,value) from Settings where Code Like 'code_cat_racx_zp_driver%') and t.Driver is null
        union all
        select 'Для категории ""Оплата заказчиком"" не заполнено поле ""Партнер""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Transactions t
        where t.Category in (select convert(int,Value) from Settings where Code Like 'code_cat_dox_zak%') and t.Partner is null
        union all
        select 'Для категории ""Закупка груза у поставщика"" не заполнено поле ""Партнер""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Transactions t
        where t.Category in (select convert(int,Value) from Settings where Code Like 'code_cat_racx_suppl%') and t.Partner is null
        union all
        select 'ОШИБКИ В РАБОТАХ:' as Тип_ошибки, '' as Кол_во_ошибок, '' as Уровень_ошибки
        union all
        select 'Поле ""Поставщик"" заполнено, а поле ""СуммаЗакуп"" пусто (или наоборот) ' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки 
        from Work w where ((COALESCE(PriceOfPurchasing,0) != 0 and Supplier is null) OR 
                          (COALESCE(PriceOfPurchasing,0) = 0 and Supplier is not null)) AND
                          (Discription is null or Discription not like '%Перенос остатков%')
        union all
        select 'Поле ""СуммаЗакуп"" заполнено, а поле ""ВалЗакуп"" пусто (или наоборот) ' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки 
        from Work w where ((PriceOfPurchasing != 0 and CurrencyPurchasing is null) OR
                          (PriceOfPurchasing = 0 and CurrencyPurchasing is not null)) AND
                          (Discription is null or Discription not like '%Перенос остатков%')
        union all
        select 'Поле ""КомиссионерПоставщика"" заполнено, а поле ""СуммаКомисПоставщика"" пусто (или наоборот) ' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Work w where ((SupplierCommission is not null and COALESCE(PriceCommissionPurchase,0) = 0) OR
                          (SupplierCommission is null and COALESCE(PriceCommissionPurchase,0) != 0)) AND
                          (Discription is null or Discription not like '%Перенос остатков%')
        union all
        select 'Поле ""КомиссионерЗаказчика"" заполнено, а поле ""СуммаКомисЗаказч"" пусто (или наоборот) ' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки
        from Work w where ((CustomerCommission is not null and COALESCE(PriceCommissionSales,0) = 0) OR
                          (CustomerCommission is null and COALESCE(PriceCommissionSales,0) != 0)) AND
                          (Discription is null or Discription not like '%Перенос остатков%')
        union all
        select 'Поле ""Водитель"" заполнено, а поле ""ЗарплВод"" пусто (или наоборот) ' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Предупреждение' as Уровень_ошибки
        from Work w where ((Driver is not null and COALESCE(SalaryDriver,0) = 0) OR
                          (Driver is null and COALESCE(SalaryDriver,0) != 0)) AND
                          (Discription is null or Discription not like '%Перенос остатков%')
        union all	
        select 'ОШИБКИ В НАСТРОЙКАХ:' as Тип_ошибки, '' as Кол_во_ошибок, '' as Уровень_ошибки
        union all
        select 'Неправильное значение настройки ""code_nalog""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Информационный' as Уровень_ошибки from Settings s where s.Code Like 'code_nalog%' and s.Value not in (select id from DictionaryCategories where Type = 2)
        union all
        select 'Неправильное значение настройки ""code_currency""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Информационный' as Уровень_ошибки from Settings s where s.Code Like 'code_currency%' and s.Value not in (select id from DictionaryCurrency)
        union all
        select 'Неправильное значение настройки ""code_cat_dox_zak""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_dox_zak%' and s.Value not in (select id from DictionaryCategories where Type = 1)
        union all
        select 'Неправильное значение настройки ""code_cat_dox_dolg""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Информационный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_dox_dolg%' and s.Value not in (select id from DictionaryCategories where Type = 1)
        union all
        select 'Неправильное значение настройки ""code_cat_racx_dolg""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Информационный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_racx_dolg%' and s.Value not in (select id from DictionaryCategories where Type = 2)
        union all
        select 'Неправильное значение настройки ""code_cat_racx_zp_driver""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_racx_zp_driver%' and s.Value not in (select id from DictionaryCategories where Type = 2)
        union all
        select 'Неправильное значение настройки ""code_cat_racx_suppl""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_racx_suppl%' and s.Value not in (select id from DictionaryCategories where Type = 2)
        union all
        select 'Неправильное значение настройки ""code_cat_racx_komisiya""' as Тип_ошибки, convert(nchar(20),count(*)) as Кол_во_ошибок, 'Критичный' as Уровень_ошибки from Settings s where s.Code Like 'code_cat_racx_komisiya%' and s.Value not in (select id from DictionaryCategories where Type = 2)
";

        public string Тип_ошибки { get; set; }
        public string Кол_во_ошибок { get; set; }
        public string Уровень_ошибки { get; set; }
    }
}
